﻿using BPA.Helper;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BPA.Model
{
    public class RawMaterInfo : NotifyBase
    {
        /// <summary>
        /// 物料信息
        /// </summary>
        /// <param name="id">原料ID</param>
        /// <param name="name">原料名称</param>
        /// <param name="dNum">原料对应设备编号</param>
        /// <param name="wNum">原料对应设备的料仓编号</param>
        /// <param name="lm">最后修改时间</param>
        public RawMaterInfo(string id, string name, int dNum, int wNum, string lm)
        {
            Id = id;
            Name = name;
            DeviceNum = dNum;
            WarehouseNum = wNum;
            LastModified = lm;
        }

        /// <summary>
        /// 物料ID
        /// </summary>
        public string Id { get { return _mId; } set { _mId = value; OnPropertyChanged(); } }
        private string _mId;

        /// <summary>
        /// 原料名称
        /// </summary>
        public string Name { get { return _mName; } set { _mName = value; OnPropertyChanged(); } }
        private string _mName;

        /// <summary>
        /// 设备编号
        /// </summary>
        public int DeviceNum { get { return _mDeviceNum; } set { _mDeviceNum = value; OnPropertyChanged(); } }
        private int _mDeviceNum;

        /// <summary>
        /// 设备料仓编号
        /// </summary>
        public int WarehouseNum { get { return _mWarehouseNum; } set { _mWarehouseNum = value; OnPropertyChanged(); } }
        private int _mWarehouseNum;

        /// <summary>
        /// 最后修改时间
        /// </summary>
        public string LastModified { get { return _mLastModified; } set { _mLastModified = value; OnPropertyChanged(); } }
        private string _mLastModified;


    }
}
