﻿using BPA.Helper;
using BPA.UIControl;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BPA.Model
{
    public class ViewItem : NotifyBase
    {
        public ViewItem(string name, object content, IconType? iconType = null)
        {
            Name = name;
            Content = content;
            Icon = iconType;
        }
        public ViewItem()
        {

        }

        /// <summary>
        /// 名称
        /// </summary>
        public string Name { get { return _mName; } set { _mName = value; OnPropertyChanged(); } }
        private string _mName;

        /// <summary>
        /// 描述
        /// </summary>
        public string Description { get { return _mDescription; } set { _mDescription = value; OnPropertyChanged(); } }
        private string _mDescription;

        /// <summary>
        /// 内容
        /// </summary>
        public object Content { get { return _mContent; } set { _mContent = value; OnPropertyChanged(); } }
        private object _mContent;

        /// <summary>
        /// 图标类型
        /// </summary>
        public IconType? Icon { get { return _mIcon; } set { _mIcon = value; OnPropertyChanged(); } }
        private IconType? _mIcon;


    }
}
